#!/usr/bin/env python
# encoding: utf-8

# ||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
# Copyright (C) 2017 Piotr Murawski
# Niniejszy program jest wolnym oprogramowaniem; mozesz go
# rozprowadzac dalej i/lub modyfikowac na warunkach Powszechnej
# Licencji Publicznej GNU, wydanej przez Fundacje Wolnego
# Oprogramowania - wedlug wersji 3-ciej tej Licencji lub ktorejs
# z pozniejszych wersji.
# Niniejszy program rozpowszechniany jest z nadzieja iz bedzie on
# uzyteczny - jednak BEZ JAKIEJKOLWIEK GWARANCJI, nawet domyslnej
# gwarancji PRZYDATNOSCI HANDLOWEJ albo PRZYDATNOSCI DO OKRESLONYCH
# ZASTOSOWAN. W celu uzyskania blizszych informacji - Powszechna
# Licencja Publiczna GNU.
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
# Z pewnoscia wraz z niniejszym programem otrzymales tez egzemplarz
# Powszechnej Licencji Publicznej GNU (GNU General Public License);
# jesli nie - napisz do Free Software Foundation, Inc., 675 Mass Ave,
# Cambridge, MA 02139, USA.
# Powszechna Licencja GNU dostepna jest rowniez na stronie:
# http://www.gnu.org/licenses/licenses.html
# nieoficjalne polskie tlumaczenie na
# http://www.gnu.org.pl
# ||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||


import serial
import time
import c14
import tools
import json
import thread

port = None

def openPort(portDevice):
	theport=None
	try:
		theport = serial.Serial(portDevice, baudrate = 9600, timeout = 2)
	except:
		print "ERROR: cant open serial port: " + str(portDevice)
		return None
	theport.flushInput()
	theport.setTimeout(0.3)
	if theport.isOpen():
		return theport  
	return None

	

def checkCrc(bajty,byte0):
	sum=0
	for i in xrange(0,29):
		if i!=1:
			sum+=ord(bajty[i])			
	sum+=byte0 & 0x7F
	sum&=0x7F
	if sum != ord(bajty[1]):
		return False 
	return True 


def getFrame(portek):
	
	state=0
	more=True	
	error=None
	frame=None
	byte0=0
	while more:
		if state==0:  
			bajt=portek.read(1)
			if len(bajt)==0:
				error='tout'
				return frame, error  
			byte0=ord(bajt[0])
		 	if byte0>127:
		 		state=1  
		if state==1:  
			bajty=portek.read(29)
			more = False			
			if len(bajty)==29:
				#print ">>  %c" % bajty[0]
				crc=checkCrc(bajty, byte0)
				if (not crc) and bajty[28]=='#':
					error='crc'
					#print "bad CRC"
				else:
					frame=c14.parseBytes(byte0, bajty)										 						
		 			#print ">>>  %c   DST:%3u   SRC:%3u " %  (frame['type'],  frame['dst'], frame['src']) 
			else:
				error='tout'
				
	return frame,error   
				


def sendRaw(portek, rawbytes):
	portek.write(rawbytes)
# 		
# 	try:
# 		bajty=portek.read(30)		
# 		print len(bajty) 
# 	except:
# 		print "dupa"
# 		pass
	#print  "%u %u %u %u " % (rmsy[3],rmsy[0],rmsy[1],rmsy[2])
		
	return
	
	
loopok=False
stats={}
stats['loopok']=False
stats['framerx']=0
stats['framerx_bcst']=0
stats['framerx_t']=0


def isLoopOk():
	return loopok


def getStats():
	return stats



def startLoop(portDevice):
	thread.start_new_thread( loop, (None, portDevice) )
	try:
		return True
	except:
		pass
	return False


tempsVals=None
bcstVals=None


def getTemps():
	return tempsVals 


def getBcst():
	return bcstVals 


def loop(tag, msg):

	print "LOOP: thread: " + str(msg)
	port = openPort(str(msg))
	
	if port==None:		
		return None 

	print "LOOP: port OK"
	
	tempcycle=0
	r470tempvals=c14.createR470tempval()
	
	loopok=True
	stats['loopok']=True
	
	global tempsVals
	global bcstVals

	stat='slave'
	masterc=0
	tout=0
	
	
	while True:
		frame,err = getFrame(port)		
		tstmp = tools.epocNow()
		
		if tout:
			if tout<tstmp:
				print "ERROR proto tout"
				stat='slave'
				tout=0				
				
		#print "||||" + str(err)
		
		#----------------------------------------------------
		#IF slave 
		if stat=='slave':
			
			if frame: 
				stats['framerx']+=1
				
				if frame['type']=='D':
					b=c14.makeFrame('E', 100, 20)
					sendRaw(port, b)
					tout=tstmp+2
															

				if frame['type']=='e':
					#print ":::" + str(frame['reply'])
					if frame['reply']==0:
						stat='master'
						tout=0
						masterc=1
			
		#----------------------------------------------------
		#if master 
		if stat=='master':
			
			if masterc==1:				
				b=c14.makeFrame('T', 1, c14.R470_TEMPS_VECTOR[tempcycle])
				sendRaw(port, b)
				tout=tstmp+2
				masterc=2				


			if masterc==3:				
				b=c14.makeFrame('D', 1)
				sendRaw(port, b)
				tout=tstmp+2
				masterc=4				

			#if pause1
			if masterc==5:				
				masterc=6
			if masterc==6:				
				masterc=1
				
			
			if frame: 
				stats['framerx']+=1
												
				if frame['type']=='t':
					stats['framerx_t']+=1
					c14.updateR470tempval(frame, r470tempvals)
					tempcycle+=1
					if tempcycle>=len(c14.R470_TEMPS_VECTOR):
						tempcycle=0
						masterc=3
					else:
						masterc=1	
					tempsVals = r470tempvals.copy()
					tout=0
					 											
					#tools.optyStoreDict('temps', '', r470tempvals, '/run')
				
				if frame['type']=='!':
					stats['framerx_bcst']+=1
					if frame['src']==1:
						#tools.optyStoreDict('bcst', '', frame['bcst'] , '/run')
						bcstVals = frame['bcst'].copy()
					if masterc!=4:
						stat='slave'
					else:
						masterc=5
				 	tout=0
				 	

				if frame['type']=='M' or (frame['type']=='D' and frame['src']!=112):
					stat='slave'

# 			if frame: 
# 				stats['framerx']+=1
# 				if frame['type']=='D':
# 					b=c14.makeFrame('T', 1, c14.R470_TEMPS_VECTOR[tempcycle])
# 					sendRaw(port, b)				
# 				
# 				if frame['type']=='t':
# 					stats['framerx_t']+=1
# 					c14.updateR470tempval(frame, r470tempvals)
# 					 
# 	# 				for t in r470tempvals:
# 	# 					print "%-10s   %5s   [%-5s] %s" % (t, r470tempvals[t][0], r470tempvals[t][2], r470tempvals[t][1])
# 					
# 					tempcycle+=1
# 					if tempcycle>=len(c14.R470_TEMPS_VECTOR):
# 						tempcycle=0
# 						
# 					#tools.optyStoreDict('temps', '', r470tempvals, '/run')
# 					tempsVals = r470tempvals.copy()
# 				
# 				if frame['type']=='!':
# 					stats['framerx_bcst']+=1
# 					if frame['src']==1:
# 						#tools.optyStoreDict('bcst', '', frame['bcst'] , '/run')
# 						bcstVals = frame['bcst'].copy() 
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
			
